/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package grafica;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.lang.*;
import javax.swing.border.*;

import pppizza.*;
/**
  * Apre una finestra di dialogo composta da una  serie di pulsanti e da una JTextArea centrale.*/
public class Finestra_principale extends JFrame implements ActionListener
{
     //oggetti necessari alla pizzeria
     private Pizzeria pizzeria;
     private Lista_Server lserver;
     private Fileordini_writer S_fordini;
     private Fileordini_writer NS_fordini;


     //oggetti per la finestra grafica
     public  JTextArea textArea;
     private JScrollPane scrollPane;
     private JButton ordiniButton;
     private JButton serverButton;
     private JButton riprisButton;
     private JButton openButton;
     private JButton closeButton;
     public  JLabel num_ordini;
     public  JLabel num_pizze;


     private JLabel open_close;




/**istanzia le variabili e gli oggetti che riceve come argomenti.*/
     public Finestra_principale(Pizzeria pz,Lista_Server ls,Fileordini_writer fs,Fileordini_writer fns)
     {
          pizzeria=pz;
          lserver=ls;
          S_fordini=fs;
          NS_fordini=fns;


          Container riga1=getContentPane();
          Box r1=Box.createHorizontalBox();
          r1.add(Box.createHorizontalStrut(8));
          open_close=new JLabel();
          r1.add(open_close);
          r1.add(Box.createGlue());
          openButton=new JButton("OPEN");
          openButton.setAlignmentY(+0.5F);
          r1.add(openButton);
          r1.add(Box.createHorizontalStrut(25));
          openButton.addActionListener(this);
          closeButton=new JButton("CLOSE");
          closeButton.setAlignmentY(+0.5f);
          r1.add(closeButton);
          closeButton.addActionListener(this);
          r1.add(Box.createHorizontalStrut(33));
          r1.add(Box.createHorizontalGlue());
          riga1.add(r1,"North");




          Container riga2=getContentPane();
          Box r2=Box.createHorizontalBox();

          r2.add(Box.createHorizontalGlue());

          Box sc1=Box.createVerticalBox();
          num_ordini=new JLabel("Ordini: "+pizzeria.getListaOrdini().conta_ordini_ToString());
          num_pizze=new JLabel("Pizze: "+pizzeria.getListaOrdini().conta_pizze());
          sc1.add(Box.createVerticalStrut(8));
          sc1.add(num_ordini);
          sc1.add(num_pizze);
          r2.add(sc1);

          r2.add(Box.createHorizontalGlue());

          Box sr1=Box.createHorizontalBox();
          ordiniButton=new JButton(new ImageIcon("icons/PIZZA.gif"));
          ordiniButton.setAlignmentY(+0.4f);
          sr1.add(ordiniButton);
          ordiniButton.addActionListener(this);
          sr1.add(Box.createHorizontalGlue());

          serverButton=new JButton("SERVER");

          sr1.add(serverButton);
          serverButton.addActionListener(this);
          serverButton.setAlignmentY(+0.4f);
          sr1.add(Box.createHorizontalGlue());

          riprisButton=new JButton("RIPRIS");
          riprisButton.setAlignmentY(+0.4f);
          sr1.add(riprisButton);
          riprisButton.addActionListener(this);
          r2.add(sr1);
          r2.add(Box.createHorizontalStrut(30));
          r2.add(Box.createHorizontalGlue());
          riga2.add(r2,"South");

          textArea=new JTextArea(8,20);
          scrollPane=new JScrollPane(textArea);
          getContentPane().add(scrollPane,"Center");
          textArea.setEditable(false);

          if(pizzeria.getStatoPizzeria().get_stato()==true)
               open_close.setIcon(new ImageIcon("icons/open.gif"));
          else
               open_close.setIcon(new ImageIcon("icons/closed.gif"));

          setTitle(pizzeria.getNome());
          setSize(400,400);

          Terminator_Fprc x=new Terminator_Fprc(this.textArea,pizzeria,lserver,NS_fordini,S_fordini);
          addWindowListener(x);

          Border bordi=BorderFactory.createEtchedBorder();
          open_close.setBorder(bordi);

     }

/**raccogli gli eventi: pressione sui pulsanti e lancia i thread necessari a servire
*le richieste.*/
     public void actionPerformed(ActionEvent evt)
     {
          Object source=evt.getSource();

          if(source==openButton)
          {
               if (pizzeria.getStatoPizzeria().get_stato()==false)
               {
                    pizzeria.getStatoPizzeria().accettaordini();
                    //creo il server che riceve le ordinazioni

	               open_close.setIcon(new ImageIcon("icons/open.gif"));
                    new ThC_OpenClose(this.textArea,pizzeria.getMsgInv(),lserver,pizzeria.getStatoPizzeria().get_stato()).start();
               }
          }


          if(source==closeButton)
          {
               if (pizzeria.getStatoPizzeria().get_stato()==true)
               {
                    pizzeria.getStatoPizzeria().rifiutaordini();
                    open_close.setIcon(new ImageIcon("icons/closed.gif"));
                    new ThC_OpenClose(this.textArea,pizzeria.getMsgInv(),lserver,pizzeria.getStatoPizzeria().get_stato()).start();
               }
          }



          if(source==ordiniButton)
          {
               Ordinazione ordine=new Ordinazione();
               ordine=pizzeria.getListaOrdini().get_ordine();
               if ((ordine!=null)&&(!pizzeria.getListaOrdini().is_empty()))
               {
                         Finestra_ordini ford=new Finestra_ordini(this,pizzeria,ordine,lserver,S_fordini);
                         JDialog fp=ford;
                         fp.show();
               }
               else textArea.append("Non ci sono ordinazioni da servire\n");

          }



          if(source==riprisButton)
          {
               lserver.riattiva_tutti();
          }


          if(source==serverButton)
          {
               lserver.stampa_lista(this.textArea);
          }
     }

}