/**
  @version aprile 2001
  @author Perticarini Emanuele
*/

package pppizza;
import java.lang.*;
import java.io.*;

/**
  * Questa classe si aspetta di leggere degli oggetti di tipo Ordinazione da un
  * file la cui PATH viene passata come argomento al costruttore.*/
public class Fileordini_reader {
     /** Contatore per le ordinazioni */
     private int     N_ordini;

     /** Stream di lettura */
     private ObjectInputStream in;

     /** PATH che identifica il file */
     protected String name;


/** Costruttore che azzera il contatore e crea lo stream di ingresso
* se non il file non esiste o non  possibile creare lo stream rilancia un IOException */
     public Fileordini_reader(String na)throws IOException
     {
          name=na;
          in=new ObjectInputStream(new FileInputStream(name));
          N_ordini=0;
     }


/** Legge un ordine dal file e lo restituisce. Restituisce null se non ha pi oggetti
* da leggere */
     public Ordinazione leggi_ordine()
     {
          Ordinazione temp=new Ordinazione();
          try{
               temp=(Ordinazione)in.readObject();
               N_ordini++;
          } catch (Exception ex)  { temp=null;}
          return temp;
     }

/** Restituisce il numero di ordini letti fino ad ora */
     public int get_num_ordini()
     {
          return N_ordini;
     }

/** ATTENZIONE: chiude lo stream di in. Quindi una volta eseguito il metodo non  pi possibile
* eseguire letture */
     public void close_read()
     {
          try{
               in.close();
          }catch(Exception e){}
     }

/** Riapre lo stream di ingresso restituisce null se non  possibile */
     public void open_read()
     {
        try
          {
               in=new ObjectInputStream(new FileInputStream(name));
               N_ordini=0;
          } catch (IOException ex)  {in=null;}
     }

     /** Azzera il contatore */
     public void azzera_count()
     {
          N_ordini=0;
     }


}
