/**
  @version aprile 2001
  @author Perticarini Emanuele
*/

package pppizza;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.util.*;


/**
  * Questa classe si aspetta di scrivere degli oggetti di tipo Ordinazione su un
  * file la cui PATH viene passata come argomento al costruttore.*/
public class Fileordini_writer {
     /** Contatore rappresentante il numero di ordini scritti */
     int     N_ordini;

     /** Streem per scrivere sul File */
     private ObjectOutputStream out;

     /** Nome del file su cui scrivere gli ordini*/
     protected String name;



/** Costruttore che azzera il contatore e crea lo stream di scrittura per il file
* se non il file non esiste o non  possibile creare lo stream lancia una IOException */
     public Fileordini_writer(String na) throws IOException
     {
         name=na;
         out=new ObjectOutputStream(new FileOutputStream(name));
         N_ordini=0;
     }


/**Scrive un oggetto ordine sul file e lo restituisce.
Non incrementa il contatore se non  possibile scrivere l'oggetto*/
     public void salva_ordine(Ordinazione ordine)
     {
          try{
               out.writeObject(ordine);
               N_ordini++;
          }catch (IOException ex)  {;}

     }



/**Salva un intera lista passate come parametro di oggetti ordinazione sul file specificato*/
     public void salva_lista_ordini(Listaordini list)
     {
          ListIterator iteratore=list.listIterator();
          while (iteratore.hasNext())
          {
               Ordinazione ordine=new Ordinazione();
               ordine=(Ordinazione)iteratore.next();
               try{
                    out.writeObject(ordine);
                    N_ordini++;
               } catch (IOException ex) {;}

          }
     }

/**restituisce il contatore*/
     public int get_num_ordini()
     {
          return N_ordini;
     }


/**ATTENZIONE: chiude lo stream di out. Quindi una volta eseguito il metodo non  pi possibile
*scrivere sul file*/
     public void close_write()
     {
          try{
               out.close();
          }catch(Exception e){}
     }

/**riapre lo streeam di scrittura. Il contatore non viene riazzerato restituisce NUll se lo stream non
* riapribile*/
    public void open_writer()
     {
          try
          {
               out=new ObjectOutputStream(new FileOutputStream(name));
               N_ordini=0;
          } catch (IOException ex)  {out=null;}
     }

/**Azzera il contatore*/
     public void azzera_count()
     {
          N_ordini=0;
     }



}
