/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.io.*;
import java.lang.*;
import java.awt.*;
import java.util.*;
import javax.swing.JTextArea;



/**
  *@Questa classe permette di creare una lista di oggetti server. Leggendoli da un file
  *@o ricevendoli come argomento in uno dei metodi dell'oggetto.
*/
public class Lista_Server extends LinkedList {


/** il costruttore crea la lista dei server conosciuti leggendoli da un file la cui path
    viene passata come argomento al costruttore */
     public Lista_Server(String path) throws IOException
     {
          super();
          BufferedReader rd= new BufferedReader(new FileReader(path));
          do
          {
               String nome=new String(rd.readLine());
               Integer porta=new Integer(rd.readLine());
               Integer stato=new Integer(rd.readLine());
               DatiServer server=new DatiServer(nome,porta.intValue(),stato.intValue());
               this.addLast(server);
          }while(rd.ready());
     }

/*controlla se nella lista esiste un serve di nome ns e porta p. In questo caso se
risulta disattivo lo attiva.*/
     public boolean aggiorna_on(String ns,int p)
     {
          boolean trovato=false;
          int porta;
          String nameserver=new String();
          nameserver=ns;
          porta=p;
          ListIterator iteratore=this.listIterator();
          int i=0;
          while (iteratore.hasNext())
          {
               DatiServer dati=new DatiServer();
               dati=(DatiServer)iteratore.next();
               if  (nameserver.equalsIgnoreCase(dati.get_name()))
               {
                    dati.stato=1;
                    this.set(i,dati);
                    trovato=true;
               }
               i++;
          }
          return trovato;
     }

/*stampa a video la lista dei server*/
     public void stampa_lista()
     {
          ListIterator iteratore=this.listIterator();
          while (iteratore.hasNext())
          {
               DatiServer dati=new DatiServer();
               dati=(DatiServer)iteratore.next();
               System.out.println("server: "+dati.get_name()+"    porta: "+dati.get_port()+"    stato: "+dati.get_stato());
          }
     }

/**stampa in finestra la lista dei server*/
     public void stampa_lista(JTextArea textArea)
     {
          ListIterator iteratore=this.listIterator();
          textArea.append("SERVER CONOSCIUTI:\n");
          while (iteratore.hasNext())
          {
               DatiServer dati=new DatiServer();
               dati=(DatiServer)iteratore.next();
               textArea.append("server: "+dati.get_name()+"    porta: "+dati.get_port()+"    stato: "+dati.get_stato()+"\n");
          }
     }





/**carica in fondo alla lista un nuovo server che gli arriva come argomento*/
     public void carica_server(String nome,int porta,int stato)
     {
          DatiServer server=new DatiServer(nome,porta,stato);
          this.addLast(server);
     }





/**Restituisce il numero di server nella lista*/
     public int num_server()
     {
          return this.size();
     }


/**Pone a 1 lo stato di tutti i server nella lista*/
     public void riattiva_tutti()
     {
          ListIterator iteratore=this.listIterator();
          int i=0;
          while (iteratore.hasNext())
          {
               DatiServer dati=new DatiServer();
               dati=(DatiServer)iteratore.next();
               if  (dati.get_stato()==0)
               {
                    dati.stato=1;
                    this.set(i,dati);
               }
               i++;
          }
      }


}


