/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.io.*;
import java.lang.*;
import java.awt.*;
import java.util.*;


/**
  @Crea una lista di oggetti ordinazione
*/
public class Listaordini extends LinkedList {
/** contatore progressivo per le ordinazioni che vengono eliminate dalla lista(cio le ordinazioni servite). */
protected int count;


/**Istanzia solo un oggetto.*/
     public Listaordini()
     {
          super();
          count=0;
     }


/** Restituisce il primo ordine in lista non spuntato */
     public synchronized Ordinazione get_ordine()
     {
          boolean continua=true;
          ListIterator iterator_temp=this.listIterator();
          Ordinazione ordine=new Ordinazione();
          while ((continua)&&(iterator_temp.hasNext()))
          {
               ordine=(Ordinazione)iterator_temp.next();
               if(!ordine.get_spuntato())
               {
                    continua=false;
                    count++;
               }
          }
          if (continua==true)
               ordine=null;
          return ordine;
     }

/** Restituisce true se la lista  vuota */
     public boolean is_empty()
     {
          return this.isEmpty();
     }


/** Aggiunge un ordine in coda alla lista */
     public synchronized void add_elem_last(Ordinazione elem)
     {
          this.addLast(elem);
     }


/** Conta il numero delle pizze totali in tutta la lista */
     public synchronized int conta_pizze()
     {
          ListIterator iterator_temp=this.listIterator();
          int i=0;
          while (iterator_temp.hasNext())
          {
               Ordinazione ordine=new Ordinazione();
               ordine=(Ordinazione)iterator_temp.next();
               i=i+ordine.num_pizze();
          }
          return i;
     }

/** restituisce il numero di pizze totali in lista in formato stringa */
     public synchronized String conta_pizze_ToString()
     {
          String temp=new String();
          temp=temp.valueOf(this.conta_pizze());
          return temp;
     }




     /** Restituisce il numero di ordini nella lista come intero */
     public int conta_ordini()
     {
          return this.size();
     }


/** Restituisce il numero di ordini nella lista come stringa */
     public String conta_ordini_ToString()
     {
          Integer temp=new Integer(this.size());
          return temp.toString();
     }


/** Carica la lista di ordini da un file la cui PATH gli viene viene passata come
* argomento */
     public synchronized void F_caricalista(String path) throws IOException
     {
          Fileordini_reader reader=new Fileordini_reader(path);
          Ordinazione ordine=new Ordinazione();
          while((ordine=reader.leggi_ordine())!=null)
               this.add_elem_last(ordine);
          reader.close_read();
     }


/** Elimina dalla lista gli ordini contenuti in un file la cui PATH viene viene passata come
*argomento */
     public synchronized void F_scaricalista(String path) throws IOException
     {
          Fileordini_reader reader=new Fileordini_reader(path);
          Ordinazione ordine=new Ordinazione();
          while((ordine=reader.leggi_ordine())!=null)
          {
               this.remove(ordine);
          }
          reader.close_read();
     }

/**Elimina dalla lista l'oggetto ordine che gli viene passato come argomento*/
     public synchronized void remove_ordine(Ordinazione ordine)
     {
               this.remove(ordine);
     }



/**Restituisce il contatore progressivo, cio il numero totale di ordini che sono stati nella lista*/
     public int get_totalcount()
     {
          return count;
     }

/**Restituisce il contatore progressivo(in formato stringa), cio il numero totale di ordini che sono stati nella lista*/
     public String get_totalcount_Tostring()
     {
          Integer temp=new Integer(count);
          return temp.toString();
     }

}
