/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.io.*;
import java.lang.Integer;



/**
  @La classe pizzeria contiene al suo interno una stringa rappresentante il nome della
  pizzeria. Una stringa per la zona. Un oggetto listaordini. Un oggetto stato_pizzeria.
  @author Perticarini Emanuele
*/
public class Pizzeria
{
     /** Indica lo stato della pizzeria (open/close) */
     protected Stato_pizzeria stato;

     /** Lista delle ordinazioni ricevute */
     protected Listaordini lordini;

     /** Nome della pizzeria */
     protected String nome;

     /** zona a cui la pizzeria appartiene */
     protected String zona;

     /** numero porta su cui attende le ordinazioni*/
     protected int porta;

     /** crea un oggetto pizzeria leggendo il nome e la zona da un file la cui path viene ricevuta
     * come parametro */
     public Pizzeria(String path,Stato_pizzeria st,Listaordini lo) throws IOException
     {
          stato=st;
          lordini=lo;
          BufferedReader leggifilenome=new BufferedReader(new InputStreamReader(new FileInputStream(path)));
          nome=new String(leggifilenome.readLine());
          zona=new String(leggifilenome.readLine());
          porta=new Integer(leggifilenome.readLine()).intValue();
          leggifilenome.close();
     }


      public String getNome()
     {
          return nome;
     }

     public String getZona()
     {
          return zona;
     }

     public String getMsgInv()
     {
//          String temp=new String(zona+","+nome+","+this.getStatoPizzeria().get_count_ToString()+","+this.getListaOrdini().conta_pizze_ToString());
          String temp=new String(zona+","+nome+","+this.getListaOrdini().conta_pizze_ToString()+","+this.getStatoPizzeria().get_count_ToString());
          return temp;
     }


     public Stato_pizzeria getStatoPizzeria()
     {
          return stato;
     }

     public Listaordini getListaOrdini()
     {
          return lordini;
     }

     public int get_porta()
     {
          return porta;
     }


     /* aggiorna lo stato della pizzeria e restituisce un stringa contenente un messaggio pronto
        da inviare ai server*/
     public synchronized String somma_ordine(Ordinazione ord)
     {
          String msg=new String();
          this.getListaOrdini().add_elem_last(ord);
          this.getStatoPizzeria().aggiorna_count();
          msg=this.getMsgInv();
          return msg;
     }

     public synchronized String elimina_ordine(Ordinazione ord)
     {
          String msg=new String();
          this.getListaOrdini().remove_ordine(ord);
          this.getStatoPizzeria().aggiorna_count();
          msg=this.getMsgInv();
          return msg;
     }

     

}