/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.io.*;
import java.lang.System;
import java.net.InetAddress;
import java.net.*;
import java.net.UnknownHostException;
import javax.swing.JTextArea;


/**
  * La classe <code>ThC_OpenClose</code> permette di creare un thread attraverso il
  * quale la pizzeria aggiorna il server inviandogli una stringa contenente la parola chiave
  * statotrue/statofalse se la pizzeria apre/chiude, il nome della pizzeria, la zona di appartenenza.
  * Se la pizzeria apre viene anche inviato il numero attuale di pizze ed il
  * valore del contatore. Tutto separato da virgole.*/
public class ThC_OpenClose extends Thread
{
     protected JTextArea textArea;
//     protected Pizzeria pizzeria;
     protected Lista_Server lserver;
     protected String msg;
     protected boolean stato;

     public ThC_OpenClose(JTextArea ta,String m,Lista_Server ls,boolean s)
     {
          super();
          textArea=ta;
//          pizzeria=p;
          lserver=ls;
          msg=m;
          stato=s;
     }




     public void run()
     {
          int i=0;
          boolean cicla=true;
          DatiServer server=new DatiServer();
          Socket client=null;
          while ((cicla) && (i<lserver.num_server()))
          {
               server=(DatiServer)lserver.get(i);
               if (server.get_stato()==1)
               {
                    try
                    {
                    //creazione della socket per la connessione fisso anche un time_out
                    //per le letture dalla socket.
                    InetAddress host=InetAddress.getByName(server.get_name());
                    client=new Socket(server.get_name(),server.get_port());
                    client.setSoTimeout(25000);

                    //apertura canali ingresso uscita
                    PrintWriter scrive=new PrintWriter (client.getOutputStream(),true);
                    BufferedReader ricevi=new BufferedReader(new InputStreamReader(client.getInputStream()));

                    //protocollo di comunicazione
                    String messaggio=new String();
                    if (stato)
                         messaggio="statotrue,"+msg;
                    else
                         messaggio="statofalse,"+msg;

                         scrive.println(messaggio);
                         textArea.append("Inviati dati al server "+server.get_name()+" : "+messaggio+"\n");
                         textArea.append("Attesa risposta\n");
                         try
                         {
                              messaggio=ricevi.readLine();

                         //eccezione che controlla il timeout nelle read dalla socket
                         }catch (SocketException ex)
                         {
                              textArea.append("Il server "+server.get_name()+" ritarda nell'IO. Collegamento ad un nuovo server\n");
                              server.stato=0;
                              lserver.set(i,server);
                              i++;
                         }
                         textArea.append("Risposta ricevuta: "+messaggio+"\n");

                         //temine comunicazione chiusura della socket e in/out
                         client.close();
                         scrive.close();
                         ricevi.close();
                         if (messaggio.equals("ok")) cicla=false;      //possibilit molto remota
                         else i++;      //se il server risponde folse ha dei problemi, quindi tento
                                             //tento l'invio dei dati ad un altro server

                         }catch (IOException ex)
                         {
                              textArea.append("Il server "+server.get_name()+" non risponde. Collegamento ad un nuovo server\n");
                              server.stato=0;
                              lserver.set(i,server);
                              i++; //per passare ad un altro server nella lista
                              try{
                                   client.close();
                              }catch(IOException cl) {textArea.append("Errore nella Close");}
                         }

                    }
               else i++;  //scelta di un altro server a cui collegarsi, solo se ce ne sono altri in lista

          }//fine while

          if(i==lserver.num_server())
          {
               try
               {
                    textArea.append("Nessun server risponde.\nLo stato della pizzeria  stato comunque valido.\nSi consiglia un controllo della rete\n");
               }catch(Exception e){;}
          }
     }//fine run





//


}









