/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.io.*;
import java.lang.System;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.net.SocketException;
import javax.swing.JTextArea;

/**
  * La classe <code>Th_aggiorna_server</code> permette di creare un thread attraverso il
  * quale la pizzeria aggiorna il server inviandogli una stringa contenente la parola chiave
  * sottrai che significa che il server deve aggiornare il numero di pizze conosciute,
  * il nome della pizzeria, la zona di appartenenza, il numero attuale di pizze ed il
  * valore del contatore. Tutto separato da virgole.*/
public class ThC_aggiorna_server extends Thread
{

     protected JTextArea textArea;
//     protected Pizzeria pizzeria;
     protected Lista_Server lserver;
     protected String msg;


     public ThC_aggiorna_server(JTextArea ta,String m,Lista_Server ls)
     {
          super();
          textArea=ta;
//          pizzeria=p;
          lserver=ls;
          msg=m;
     }


     public void run()
     {
          int i=0;
          boolean cicla=true;
          DatiServer server=new DatiServer();
          Socket client=null;
          msg="sottrai,"+msg;
          while ((cicla) && (i<lserver.num_server()))
               {
                    server=(DatiServer)lserver.get(i);
                    if (server.get_stato()==1)
                    {
                         try
                         {
                              //creazione della socket per la connessione fisso anche un time_out
                              //per le letture dalla socket.
                              InetAddress host=InetAddress.getByName(server.get_name());
                              client=new Socket(server.get_name(),server.get_port());
                              client.setSoTimeout(60000);

                              //apertura canali ingresso uscita
                              PrintWriter scrive=new PrintWriter (client.getOutputStream(),true);
                              BufferedReader ricevi=new BufferedReader(new InputStreamReader(client.getInputStream()));

                              //protocollo di comunicazione
                              scrive.println(msg);
                              textArea.append("Inviati dati al server "+server.get_name()+" : "+msg+"\n");  // un controllo
                              textArea.append("Attesa risposta\n");
                              String messaggio=new String();
                              try
                              {
                                   messaggio=ricevi.readLine();
                                   textArea.append("Risposta ricevuta: "+messaggio+"\n");
                              //eccezione che controlla il timeout nelle read dalla socket
                              }catch (SocketException ex)
                              {
                                   textArea.append("Il server "+server.get_name()+" ritarda nell'IO. Collegamento ad un nuovo server\n");
                                   server.stato=0;
                                   lserver.set(i,server);
                                   i++;
                              }
                              //temine comunicazione chiusura della socket e in/out
                              client.close();
                              scrive.close();
                              ricevi.close();
                              if (messaggio.equals("ok")) cicla=false;  //tuttu  andato a buon fine
                              else i++;      //se il server risponde forse ha dei problemi, quindi
                                             //ritento l'invio dei dati ad un altro server, comunque resta
                                             //attivo nella lista, nella speranza che risolva i problemi
                                             //prima del prossimo invio di dati

                         }catch (IOException ex)
                         {
                              textArea.append("Il server "+server.get_name()+" non risponde o errore nel protocollo di comunicazione.\n Collegamento ad un nuovo server\n");
                              server.stato=0;
                              lserver.set(i,server);
                              i++; //per passare ad un altro server nella lista
                              try{
                                   client.close();
                              }catch(IOException cl) {textArea.append("Errore nella Close");}
                         }

                    }else i++;  //scelta di un altro server a cui collegarsi

               }//fine while



          if(i==lserver.num_server()) textArea.append("Non  stato possibile aggiornare i server.\nVerificare il corretto funzionamento della rete\n");

     }//fine run



}
