/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;

import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;

import org.xml.sax.*;
import org.xml.sax.helpers.*;
import javax.xml.parsers.*;

import grafica.Finestra_principale;

/**
  * La classe <code>ThS_servitore</code>  un thread che acceta tra i parametri
  * di ingresso dell'unico costruttore a disposizione un oggetto Socket grazie al quale
  * continua la comunicazione avviata da una ServerSocket. Compito di questo Thread 
  * ricevere le ordinazioni che arrivano in formato xml. Questo grazie ad un parser Sax
  * fornito dai packeg  org.xml.sax e javax.xml.parser
*/
public class ThS_Servitore extends Thread
{
     protected Socket client;
     protected Finestra_principale fp;
     protected BufferedReader ricevi;
     protected PrintWriter invia;
     protected Pizzeria pizzeria;
     protected Fileordini_writer NS_fordini;

    protected String appoggio;


     public ThS_Servitore(Socket cl,Finestra_principale f,Pizzeria pz,Fileordini_writer fo,int c)
     {
          this.client=cl;
          this.fp=f;
          this.pizzeria=pz;
          this.NS_fordini=fo;
          this.appoggio="";
          this.appoggio=appoggio.valueOf(c);
     }



     public void run()
     {
          try
          {
               
               
               //creo flussi di ingresso uscita per comunicare con i server centrali
               invia=new PrintWriter (client.getOutputStream(),true);
               ricevi=new BufferedReader(new InputStreamReader(client.getInputStream()));

               
 
               //eseguo il protocollo di comunicazione con il server centrale
               String messaggio=(String)new String(ricevi.readLine());

               fp.textArea.append("Messaggio ricevuto: ");
               fp.textArea.append(messaggio+"\n");

               if ((pizzeria.getStatoPizzeria().get_stato()==false) || (!(messaggio.equalsIgnoreCase("ordine"))))
               {
                    invia.println("false");
                    invia.close();
                    ricevi.close();
                    client.close();
               }
               else
               {
                    invia.println("true");

                    /*////////////////////////////////////
                    codice per la ricezione di un file xml
                    ////////////////////////////////////*/

                    //canale di lettura per l'ordinazione

                    try{

		         String xml_msg=(String)new String(ricevi.readLine());

                         //preparo il file xml per il parsing
                         String namefilexml=new String("fileordini/"+pizzeria.getNome());

                                                 
                         namefilexml=namefilexml+appoggio+".xml";
                         System.out.println(namefilexml);
                         PrintWriter out=new PrintWriter (new FileWriter(namefilexml));
                         out.print(xml_msg);
                         out.close();

                         //creo l'oggetto ordinazione dal file xml
                         Ordinazione ordine=new Ordinazione();
                         SAXParser parser =SAXParserFactory.newInstance().newSAXParser();
                         Xmlparsing init=new Xmlparsing(ordine);
                         parser.parse(new File(namefilexml),init);

                         //aggiorno la pizzeria aggiungendo l'ordine alla lista degli ordini
                         //e aggiornando il contatore
                         appoggio=pizzeria.somma_ordine(ordine);


                         File clear=new File(namefilexml);
                         clear.delete();

			 System.out.println("Cancellato file: "+namefilexml);

			 

			 
                         //aggiungo l'ordine al file ordini di backup e stampo l'ordine ricevuto a video
                         NS_fordini.salva_ordine(ordine);
                         fp.textArea.append("Ricevuto nuovo ordine\n");
                         ordine.stampaordine(fp.textArea);
                    }catch(Exception ex)  {fp.textArea.append("Errore nella lettura\n");}

                    //invio ai server centrali la comunicazione di fine acquisizione ordine

                    fp.num_ordini.setText("Ordini: "+pizzeria.getListaOrdini().conta_ordini_ToString()+";");
                    fp.num_pizze.setText("Pizze: "+pizzeria.getListaOrdini().conta_pizze());

                    invia.println(appoggio);

                    invia.close();
                    ricevi.close();
                    client.close();

               }
          }catch (Exception ex)
          {
               fp.textArea.append("Errore nella comunicazione\n");
               try{
                    client.close();
               }catch(IOException cl) {System.out.println("Errore nella Close");}
          }
     }
}
