/**
  @version aprile 2001
  @author Perticarini Emanuele
*/
package pppizza;
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import grafica.Finestra_principale;
import javax.swing.JOptionPane;


/**
  * La classe <code>Ths_attesa_ordinie</code> permette di creare un thread che apre
  * una serversocket che attende le ordinazioni. Una volta ricevuta una richiesta
  * controlla se conosce l'Host che si  collegato. In questo caso passa la comunicazione ad
  * un thread servitore che esegue il servizio, a questo punto si rimette in attesa degli
  * ordini.
  * Questo threads tenta l'apertura della soket per tre volte, se non ci riesce
  * invia un messaggio all'utente e poi chiude il programma  */
public class ThS_attesa_ordini extends Thread
{
     Finestra_principale fp;
     Pizzeria pizzeria;
     Lista_Server lserver;
     Fileordini_writer NS_fordini;

    protected int count;

    

    
     public ThS_attesa_ordini(Finestra_principale f,Pizzeria pz ,Lista_Server ls,Fileordini_writer fo)
     {
          super();
          this.fp=f;
          this.pizzeria=pz;
          this.lserver=ls;
          this.NS_fordini=fo;
          count=0;
     }




     public void run()
     {
          int i=0;
          /*ciclo che tenta per tre volte la creazione di una ServerSocket per ricevere le ordinazioni.
            Se fallisce per quattro volte avvisa l'utente del problema, e notifica ai server la chiusura della pizzeria.
            Se invece la Socket  creata in modo corretto il ciclo viene eseguito una sola volta*/
          while(i<=3)
          {
               try
               {
                    //creo un servre socket in attesa sulla porta specificata
                    ServerSocket server=new ServerSocket(pizzeria.get_porta());
                    do
                    {
                         Socket client=server.accept();
                         String destName=client.getInetAddress().getHostName();
                         int destPort=client.getPort();
//                         fp.textArea.append("Collegamento da: "+destName+" sulla porta: "+destPort+"\n");
                         if(lserver.aggiorna_on(destName,destPort))
                              new ThS_Servitore(client,fp,pizzeria,NS_fordini,count).start();
                         else
                              fp.textArea.append("Collegamento da un Host sconosciuto!\nRichiesta rifiutata\n");
                         
                         if(count==50000)
                         	count=0;
                         else
                         	count++;
                         

                    }while(true);

               } catch (IOException ex)
               {
                    fp.textArea.append("Errore nella creazione della ServerSocket\n");
                    fp.textArea.append("Attesa\n");
                    try{
                         this.sleep(3000);
                    }catch(InterruptedException ie) {}
                    fp.textArea.append("ritento la connesione\n");
                    i++;
               }
          }//esco dalla prima while
          if(i==4)
          {
               JOptionPane.showMessageDialog(null, "Errore nell'apertura della ServerSocket.\nControllare le porte di sistema e ritentare l'apertura", "Error ServerSocket", JOptionPane.ERROR_MESSAGE);
               System.exit(0);
               fp.textArea.append("Impossibile ricevere le ordinazioni.\n");
               fp.textArea.append("Controllare i possibili problemi e ritentare l'apertura della pizzeria\n");
               pizzeria.getStatoPizzeria().rifiutaordini();
               new ThC_OpenClose(fp.textArea,pizzeria.getMsgInv(),lserver,pizzeria.getStatoPizzeria().get_stato()).start();
          }
     }

}

