/**
  @version aprile 2001
  @author Perticarini Emanuele
*/

package pppizza;
import javax.swing.*;

/**
  * La classe <code>Th_RiattivaServer</code> permette di creare un thread nel quale
  * ogni 5 minuti viene rimesso a 1 lo stato di tutti i server conosciuti, e se
  * la pizzeria  aperta e non ha ricevuto o non ha comunicato ordinazioni

  * viene lanciato il thread implementato nella classe ThC_OpenClose per

  * comunicare ai server centrali che la pizzeria  aperta */


public class Th_RiattivaServer extends Thread{
     /** Spazio in cui si visualizzano le stampe */
     protected JTextArea textArea;

     /** Pizzeria conosciuta dal sistema */
     protected Pizzeria pizzeria;

     /** lista dei server conosciuti */
     protected Lista_Server lserver;



     public Th_RiattivaServer(JTextArea ta,Pizzeria pz,Lista_Server ls)
     {
          super();
          textArea=ta;
          pizzeria=pz;
          lserver=ls;
     }


/** Ogni 10 minuti si riattiva lo stato di tutti i server nella lista e se la pizzeria 
* aperta viene lanciato il thread implementato nella classe ThC_OpenClose */
     public void run()
     {
          int count;
          while(true)
          {
               try
               {
                    lserver.riattiva_tutti();
                    count=pizzeria.getStatoPizzeria().get_count();
                    this.sleep(30000);
                    if((count==pizzeria.getStatoPizzeria().get_count())&&(pizzeria.getStatoPizzeria().get_stato()))
                    {
                         new ThC_OpenClose(textArea,pizzeria.getMsgInv(),lserver,pizzeria.getStatoPizzeria().get_stato()).start();
                    }

               }catch(InterruptedException Ie){}
          }
     }


}