package monitor;

/**
 *  Classe Mutex per garantire la mutua esclusione.
 *  @author Cesare Stefanelli e Antonio Corradi.
 *  @version Monitor 1.0 
 */
public class Mutex { 
	private boolean occupato = false;
	
	/** Sospensione se risorsa occupata. */
	synchronized public void MutexWait() { 
		if (occupato)
	            try{ 
				wait(); 
			} catch(InterruptedException e){}
		occupato = true;
	}

	/** Rilascio risorsa e risveglio processi sospesi. */
	synchronized public void MutexSignal() { 
		occupato = false;
		notify(); 
	}

}

