package monitor;

/**
 *  Classe Urgent per sospensione dei processi che eseguono la Signal.
 *  @author Cesare Stefanelli e Antonio Corradi.
 *  @version Monitor 1.0 
 */
public class Urgent {
	private int urgentCount = 0;
	
	/** Sospensione su coda Urgent (a seguito di una signal sospensiva su una var condizione). */
	synchronized public void urgentWait() {
		urgentCount++;
            try{ 
			wait(); 
		} catch(InterruptedException e){}
		urgentCount--;
	}

	/** Signal per risveglio processi. */
	synchronized public void urgentSignal() {
		notify(); 
	}

	/** 
	 * Verifica la presenza di processi sospesi sulla Variabile Condizione.
	 * @return ritorna true se ci sono processi sospesi, false altrimenti
	 */
	synchronized public boolean queue() {
		if (urgentCount > 0) return true;
		else return false;
	}


}

