package monitor2;

/**
 *  Classe Mutex per garantire la mutua esclusione.
 *  @author Cesare Stefanelli e Antonio Corradi
 *  @author modificato da G. C. e L.L.
 *  @version Monitor 1.1 
 */
public class Mutex { 
	private boolean occupato = false;
	
	/** Sospende il processo se la risorsa &egrave; occupata. */
	synchronized public void Wait() { 
		if (occupato)
	            try{ 
				wait(); 
			} catch(InterruptedException e){}
		occupato = true;
	}

	/** Rilascia la risorsa e risveglia un processo sospeso. */
	synchronized public void Signal() { 
		occupato = false;
		notify(); 
	}

}

